import { computed as V, watch as ue, ref as Z, defineComponent as Ne, provide as De, toRefs as Me, useSlots as Oe, onMounted as Be, openBlock as S, createElementBlock as k, Fragment as U, createElementVNode as z, normalizeClass as J, unref as e, renderSlot as $, normalizeProps as ve, mergeProps as j, renderList as Y, toDisplayString as M, withModifiers as _e, createCommentVNode as te, createTextVNode as K } from "vue";
const je = {
  items: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of data objects, should be a flat array."
  },
  measures: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of Measure objects representing the metrics"
  },
  dimensions: {
    type: Array,
    default: () => [],
    description: "Array of Dimension objects representing the row-dimensions"
  },
  pivot: {
    type: Object,
    default: null,
    description: "Single Pivot object representing the column-dimension. Limited to 1 for reduced complexity."
  },
  locale: {
    type: String,
    default: "en-US",
    description: "Locale setting for the table."
  },
  currentPage: {
    type: Number,
    default: 1,
    description: "Current page number."
  },
  noRowsCustom: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to use custom rows when no data is available."
  },
  emptyMessage: {
    type: String,
    default: "No Available Data",
    description: "Message to display when there is no available data."
  },
  filterOptions: {
    type: Array,
    default: null,
    description: "Array of filter options for the table."
  },
  hideFooter: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table footer."
  },
  hideHeader: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table header."
  },
  loading: {
    type: Boolean,
    default: !1,
    description: "Indicates whether the table is in a loading state."
  },
  rowsPerPage: {
    type: Number,
    default: 25,
    description: "Number of rows per page."
  },
  searchField: {
    type: [String, Array],
    default: "",
    description: "Field or fields to search within."
  },
  rowsItems: {
    type: Array,
    default: () => [25, 50, 100]
  },
  rowsOfPageSeparatorMessage: {
    type: String,
    default: "of"
  },
  searchValue: {
    type: String,
    default: "",
    description: "Value to search for within the specified field(s)."
  },
  showIndex: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to display an index column."
  },
  showIndexSymbol: {
    type: String,
    default: "#",
    description: "Symbol used for the index column."
  },
  showIndexClass: {
    type: String,
    default: "",
    description: "Class used for the index column."
  },
  oddRowClass: {
    type: String,
    default: "odd-row",
    description: "CSS class applied to odd-numbered rows."
  },
  evenRowClass: {
    type: String,
    default: "even-row",
    description: "CSS class applied to even-numbered rows."
  },
  oddRowCellClass: {
    type: String,
    default: "odd-row-cell",
    description: "CSS class applied to cells in odd-numbered rows."
  },
  customTableRowClass: {
    type: Function,
    default: () => null,
    description: "Custom function to apply classes to tablerows <tr>."
  },
  customTableDataClass: {
    type: Function,
    default: () => null,
    description: "Custom function to apply classes to tablerows <td>."
  },
  evenRowCellClass: {
    type: String,
    default: "even-row-cell",
    description: "CSS class applied to cells in even-numbered rows."
  },
  sortBy: {
    type: String,
    default: "",
    description: "Field or fields to sort by."
  },
  sortType: {
    type: String,
    default: "asc",
    description: "Sort type or types (ascending or descending)."
  },
  sortPivotValue: {
    type: String,
    default: "",
    description: "Sort pivotValue when pivot is active"
  },
  tableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table element."
  },
  innerTableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the inner table element."
  },
  headerClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table header element."
  },
  mustSort: {
    type: Boolean,
    default: !1,
    description: "Indicates whether sorting is required."
  },
  tableNodeId: {
    type: String,
    default: "",
    description: "ID attribute for the table element."
  },
  nullFillText: {
    type: String,
    default: "-",
    description: "Text to be shown if cellvalue is null"
  },
  splitDimensionHeaders: {
    type: Boolean,
    default: !1,
    description: "Forces spit of dimension headers into separate cells."
  }
};
function q(s, a) {
  if (s.includes(".")) {
    const p = s.split("."), { length: i } = p;
    let o, c = 0;
    for (; c < i; ) {
      if (c === 0)
        o = a[p[0]];
      else if (o && typeof o == "object")
        o = o[p[c]];
      else {
        o = "";
        break;
      }
      c += 1;
    }
    return o ?? "";
  }
  return a[s];
}
function Pe(s, a, p, i) {
  return s == null ? i : Array.isArray(s) ? s.join(", ") : (a.formatFunc ? s = a.formatFunc(s) : a.numberFormat && (s = new Intl.NumberFormat(p, a.numberFormat).format(s)), a.prefix && (s = a.prefix + s), a.suffix && (s = s + a.suffix), s);
}
function he(s, a, p, i) {
  const o = q(s.value, a);
  return Pe(o, s, p, i);
}
function Ce(s, a, p, i, o) {
  var T;
  let c;
  return s.pivotValue ? c = (T = a.items.find((I) => I[p.value] === s.pivotValue)) == null ? void 0 : T[s.value] : c = q(s.value, a.dimensions), Pe(c, s, i, o);
}
function Le(s, a, p, i, o, c, T, I, y) {
  const H = (h) => {
    if (typeof T.value == "string" && T.value !== "")
      return q(T.value, h);
    if (Array.isArray(T.value)) {
      let n = "";
      return T.value.forEach((f) => {
        n += q(f, h);
      }), n;
    }
    return Object.values(h).join(" ");
  }, O = V(() => {
    if (o.value) {
      const h = c.value.map((f) => f.value), n = i.value.reduce((f, g) => {
        const m = h.map((w) => g[w]).join("|"), C = f.find((w) => w.key === m);
        if (C)
          C.items.push(g);
        else {
          const w = Object.fromEntries(Object.entries(g).filter(([d]) => h.includes(d)));
          f.push({ key: m, dimensions: w, items: [g] });
        }
        return f;
      }, []);
      if (I.value !== "") {
        const f = new RegExp(I.value, "i");
        return n.filter((g) => f.test(g.key));
      }
      return n;
    }
    if (I.value !== "") {
      const h = new RegExp(I.value, "i");
      return i.value.filter((n) => h.test(H(n)));
    }
    return i.value;
  }), N = V(() => {
    let h = [...O.value];
    return o.value ? h : p.value ? (p.value.forEach((n) => {
      h = h.filter((f) => {
        const { field: g, comparison: m, criteria: C } = n;
        if (typeof m == "function")
          return m(q(g, f), C);
        const w = q(g, f);
        if (w === null)
          return !1;
        switch (m) {
          case "=":
            return w === C;
          case "!=":
            return w !== C;
          case ">":
            return w > C;
          case "<":
            return w < C;
          case "<=":
            return w <= C;
          case ">=":
            return w >= C;
          case "between":
            return w >= Math.min(...C) && w <= Math.max(...C);
          case "in":
            return Array.isArray(C) ? C.includes(w) : !0;
          default:
            return w === C;
        }
      });
    }), h) : O.value;
  });
  ue(
    N,
    (h) => {
      p.value && y("updateFilter", h);
    },
    { immediate: !0, deep: !0 }
  );
  const L = V(() => {
    var w;
    if (a.value === null)
      return N.value;
    const h = [...N.value], { sortBy: n, sortDesc: f, sortPivotValue: g } = a.value, m = (w = s.value.find((d) => d.value === n)) == null ? void 0 : w.sortFunc;
    return h.sort((d, v) => {
      var P, R, F, E;
      let l, r;
      return o.value ? g ? (l = m ? m((P = d.items.find((B) => B[o.value.value] === g)) == null ? void 0 : P[n]) : (R = d.items.find((B) => B[o.value.value] === g)) == null ? void 0 : R[n], r = m ? m((F = v.items.find((B) => B[o.value.value] === g)) == null ? void 0 : F[n]) : (E = v.items.find((B) => B[o.value.value] === g)) == null ? void 0 : E[n]) : (l = m ? m(d.dimensions[n]) : d.dimensions[n], r = m ? m(v.dimensions[n]) : v.dimensions[n]) : (l = m ? m(q(n, d)) : q(n, d), r = m ? m(q(n, v)) : q(n, v)), l == null && r != null ? 1 : l != null && r == null ? -1 : l == null && r == null ? 0 : l < r ? f ? 1 : -1 : l > r ? f ? -1 : 1 : 0;
    });
  }), Q = V(() => L.value.length);
  return {
    totalItems: L,
    totalItemsLength: Q
  };
}
function Ee(s, a, p, i, o, c, T, I, y, H, O, N, L) {
  const Q = V(() => o.value ? [...new Set(s.value.map((d) => d[o.value.value]))] : []), n = Z(
    ((d, v, l) => d && d !== "" ? {
      sortBy: d,
      sortDesc: v === "desc",
      sortPivotValue: l
    } : null)(y.value, H.value, O.value)
  );
  let f = [];
  const g = V(() => {
    if (o.value) {
      const l = Q.value.flatMap((r) => i.value.map((R) => ({
        ...R,
        pivotValue: r
      })));
      f = [
        ...p.value.map((r) => ({ ...r, type: "tableRow" })),
        ...l.map((r) => ({ ...r, type: "tableValue" }))
      ];
    } else
      f = [
        ...p.value.map((l) => ({ ...l, type: "tableRow" })),
        ...i.value.map((l) => ({ ...l, type: "tableValue" }))
      ];
    const d = f.map((l) => {
      const r = Object.assign(l);
      return r.sortable && (r.sortType = "none"), n.value && r.value === n.value.sortBy && n.value.sortPivotValue ? n.value.sortPivotValue === r.pivotValue ? r.sortType = n.value.sortDesc ? "desc" : "asc" : r.sortType = "none" : n.value && r.value === n.value.sortBy && (r.sortType = n.value.sortDesc ? "desc" : "asc"), r;
    });
    let v = [];
    return T.value ? v = [{
      text: a.value,
      value: "index",
      cssClass: I.value
    }, ...d] : v = d, v;
  }), m = V(() => {
    const d = [];
    if (o.value) {
      const v = g.value.reduce(
        (l, r) => {
          var E, B;
          const P = r.pivotValue;
          let R;
          r.pivotValue ? o.value.formatFunc ? R = o.value.formatFunc(r.pivotValue) : R = r.pivotValue : R = null;
          const F = l[l.length - 1];
          return F && (r.type === "tableValue" || !N.value) && (((E = F.parent) == null ? void 0 : E.text) !== null || ((B = r.parent) == null ? void 0 : B.text) !== null) && F.text === R && !F.isIndex && F.originalText === P ? F.count++ : l.push({
            type: "pivot",
            isIndex: r.value === "index",
            text: R,
            originalText: P,
            count: 1,
            cssClass: r.cssClass ?? "",
            parent: r.parent
          }), l;
        },
        []
      );
      d.push(v);
    }
    if (g.value.findIndex((v) => v.parent) > -1) {
      const v = g.value.reduce(
        (l, r) => {
          var E;
          const P = ((E = r.parent) == null ? void 0 : E.text) || null, R = r.pivotValue, F = l[l.length - 1];
          return F && (r.type === "tableValue" || !N.value) && (F.text !== null || P !== null) && F.text === P && !F.isIndex && F.pivotValue === R ? F.count++ : l.push({
            type: "parent",
            isIndex: r.value === "index",
            pivotValue: R,
            text: P,
            count: 1,
            cssClass: r.cssClass ?? ""
          }), l;
        },
        []
      );
      d.push(v);
    }
    return d;
  }), C = V(() => g.value.map((d) => d.value));
  return {
    clientSortOptions: n,
    headerColumns: C,
    headersForRenderParents: m,
    headersForRender: g,
    updateSortField: (d, v, l = !1, r = void 0) => {
      let P = null;
      l ? P = v === "none" ? null : v : v === "none" ? P = "asc" : v === "asc" ? P = "desc" : P = c.value ? "asc" : null, P === null ? n.value = null : n.value = {
        sortBy: d,
        sortDesc: P === "desc",
        sortPivotValue: r
      }, L("updateSort", {
        sortPivotValue: r,
        sortType: P,
        sortBy: d
      });
    }
  };
}
function ze(s, a) {
  const p = V(() => s.value.findIndex((c) => c === a.value) === -1 ? [a.value, ...s.value] : s.value), i = Z(a.value);
  return {
    rowsItemsComputed: p,
    rowsPerPageRef: i,
    updateRowsPerPage: (c) => {
      i.value = c;
    }
  };
}
function He(s, a, p, i) {
  const o = Z(s.value), c = V(() => Math.ceil(p.value / i.value)), T = V(
    () => c.value === 0 || o.value === c.value
  ), I = V(() => o.value === 1);
  return {
    currentPaginationNumber: o,
    maxPaginationNumber: c,
    isLastPage: T,
    isFirstPage: I,
    nextPage: () => {
      p.value !== 0 && (T.value || a.value || (o.value += 1));
    },
    prevPage: () => {
      p.value !== 0 && (I.value || a.value || (o.value -= 1));
    },
    updatePage: (L) => {
      a.value || (o.value = L);
    },
    updateCurrentPaginationNumber: (L) => {
      o.value = L;
    }
  };
}
function Ge(s, a, p, i, o) {
  const c = V(() => (s.value - 1) * a.value + 1), T = V(() => Math.min(i.value.length, s.value * a.value)), I = V(() => a.value === -1 ? i.value : i.value.slice(c.value - 1, T.value)), y = V(() => p.value ? o.value ? I.value.map((O, N) => (O.dimensions = { index: c.value + N, ...O.dimensions }, O)) : I.value.map((O, N) => ({ index: c.value + N, ...O })) : I.value), H = V(() => y.value);
  return {
    currentPageFirstIndex: c,
    currentPageLastIndex: T,
    pageItems: H
  };
}
const qe = [
  { name: "scroll", description: "Triggered when scrolling" },
  { name: "clickRow", description: "Triggered when a row is clicked" },
  { name: "clickCell", description: "Triggered when a cell is clicked" },
  { name: "updateSort", description: "Triggered when sorting is updated" },
  { name: "updateFilter", description: "Triggered when filtering is updated" },
  { name: "updatePageItems", description: "Triggered when page items are updated" },
  { name: "updateTotalItems", description: "Triggered when total items are updated" },
  { name: "mouseover", description: "Triggered when mouse is over" },
  { name: "mouseleave", description: "Triggered when mouse leaves" }
], We = qe.map((s) => s.name), Ue = ["id"], Ke = ["colspan"], Je = { class: "header" }, Qe = {
  key: 3,
  class: "header-text"
}, Xe = ["onClick"], Ye = { class: "header" }, Ze = {
  key: 3,
  class: "header-text"
}, et = ["id"], tt = ["role", "onClick", "onMouseover", "onMouseleave"], st = { id: "errors" }, rt = { style: { color: "red" } }, ot = { key: 6 }, nt = /* @__PURE__ */ Ne({
  __name: "PivotDataTable",
  props: je,
  emits: We,
  setup(s, { expose: a, emit: p }) {
    const i = Z([]), o = Z();
    De("dataTable", o);
    const c = s, {
      measures: T,
      dimensions: I,
      pivot: y,
      locale: H,
      tableNodeId: O,
      currentPage: N,
      filterOptions: L,
      emptyMessage: Q,
      noRowsCustom: h,
      items: n,
      loading: f,
      mustSort: g,
      rowsItems: m,
      rowsPerPage: C,
      searchField: w,
      searchValue: d,
      showIndex: v,
      sortBy: l,
      sortType: r,
      sortPivotValue: P,
      showIndexSymbol: R,
      showIndexClass: F,
      nullFillText: E,
      hideFooter: B,
      customTableRowClass: Se,
      customTableDataClass: ke,
      splitDimensionHeaders: Ie
    } = Me(c), _ = Oe(), ee = p, { clientSortOptions: xe, headersForRenderParents: Te, headersForRender: G, updateSortField: se } = Ee(
      n,
      R,
      I,
      T,
      y,
      g,
      v,
      F,
      l,
      r,
      P,
      Ie,
      ee
    ), { totalItems: fe, totalItemsLength: re } = Le(
      G,
      xe,
      L,
      n,
      y,
      I,
      w,
      d,
      ee
    ), { rowsItemsComputed: Fe, rowsPerPageRef: oe, updateRowsPerPage: $e } = ze(m, C), { currentPaginationNumber: ie, maxPaginationNumber: de, isLastPage: ye, isFirstPage: ge, nextPage: ne, prevPage: ae, updatePage: le } = He(N, f, re, oe), { currentPageFirstIndex: pe, currentPageLastIndex: ce, pageItems: me } = Ge(
      ie,
      oe,
      v,
      fe,
      y
    ), Ve = (u, A, t, b) => {
      ee("clickCell", u, A, t, b);
    };
    ue(oe, () => {
      le(1);
    }), ue([d, L], () => {
      le(1);
    }), ue(
      [n, y],
      () => {
        Re();
      },
      { immediate: !0 }
    );
    const we = Z(!1);
    function Re() {
      i.value = [], y.value && Array.isArray(y.value) ? i.value.push({
        type: "propError",
        text: "pivot is of type Array"
      }) : y.value && Ae() && i.value.push({
        type: "dataShapeError",
        text: "duplicate item Objects (by rows * columns) found in items"
      });
    }
    Be(() => {
      o.value.addEventListener("scroll", () => {
        we.value = o.value.scrollLeft > 0;
      });
    }), a({
      currentPageFirstIndex: pe,
      currentPageLastIndex: ce,
      clientItemsLength: re,
      totalItems: fe,
      maxPaginationNumber: de,
      currentPaginationNumber: ie,
      isLastPage: ye,
      isFirstPage: ge,
      nextPage: ne,
      prevPage: ae,
      updatePage: le,
      updateSortField: se,
      rowsPerPageOptions: Fe,
      rowsPerPageActiveOption: oe,
      updateRowsPerPageActiveOption: $e
    });
    function Ae() {
      const u = [...I.value.map((t) => t.value), y.value.value], A = /* @__PURE__ */ new Set();
      for (let t = 0; t < n.value.length; t++) {
        const b = u.map((x) => n.value[t][x]).join("|");
        if (A.has(b))
          return !0;
        A.add(b);
      }
      return !1;
    }
    return (u, A) => (S(), k(U, null, [
      z("div", {
        ref_key: "dataTable",
        ref: o,
        class: J(["vue3-pivot-data-table", [u.tableClassName]]),
        onScroll: A[0] || (A[0] = (t) => u.$emit("scroll", t))
      }, [
        z("table", {
          id: e(O),
          class: J({
            [u.innerTableClassName]: !0,
            "show-shadow": we.value
          })
        }, [
          e(_)["customize-headers"] ? $(u.$slots, "customize-headers", ve(j({ key: 0 }, { headersForRender: e(G), updateSortField: e(se) })), void 0, !0) : e(G).length && !u.hideHeader ? (S(), k("thead", {
            key: 1,
            class: J([u.headerClassName])
          }, [
            (S(!0), k(U, null, Y(e(Te), (t, b) => (S(), k("tr", {
              key: "headerRowGroup" + b
            }, [
              (S(!0), k(U, null, Y(t, (x, D) => (S(), k("th", {
                key: "pivotHeader" + D,
                colspan: x.count,
                class: J([
                  {
                    shadow: D === 0,
                    [x.cssClass ?? ""]: !0,
                    [x.type ?? ""]: !0
                  }
                ])
              }, [
                z("span", Je, [
                  e(_)[`header-${x.type}-${x.text}`] ? $(u.$slots, `header-${x.type}-${x.text}`, j({
                    key: 0,
                    ref_for: !0
                  }, x), void 0, !0) : e(_)[`header-${x.type}`] ? $(u.$slots, `header-${x.type}`, j({
                    key: 1,
                    ref_for: !0
                  }, x), void 0, !0) : e(_).header ? $(u.$slots, "header", j({
                    key: 2,
                    ref_for: !0
                  }, x), void 0, !0) : (S(), k("span", Qe, M(x.text), 1))
                ])
              ], 10, Ke))), 128))
            ]))), 128)),
            z("tr", null, [
              (S(!0), k(U, null, Y(e(G), (t, b) => (S(), k("th", {
                key: b,
                role: "button",
                tabindex: 0,
                class: J([
                  {
                    sortable: t.sortable,
                    none: t.sortable && t.sortType === "none",
                    desc: t.sortable && t.sortType === "desc",
                    asc: t.sortable && t.sortType === "asc",
                    shadow: b === 0,
                    [t.cssClass ?? ""]: !0,
                    [t.type ?? ""]: !0
                  }
                ]),
                onClick: _e((x) => t.sortable && t.sortType ? e(se)(t.value, t.sortType, !1, t.pivotValue) : null, ["stop"])
              }, [
                z("span", Ye, [
                  e(_)[`header-${t.value}`] ? $(u.$slots, `header-${t.value}`, j({
                    key: 0,
                    ref_for: !0
                  }, t), void 0, !0) : e(_)[`header-${t.value.toLowerCase()}`] ? $(u.$slots, `header-${t.value.toLowerCase()}`, j({
                    key: 1,
                    ref_for: !0
                  }, t), void 0, !0) : e(_).header ? $(u.$slots, "header", j({
                    key: 2,
                    ref_for: !0
                  }, t), void 0, !0) : (S(), k("span", Ze, M(t.text), 1)),
                  t.sortable && e(_)["sort-icon"] ? $(u.$slots, "sort-icon", j({
                    key: 4,
                    ref_for: !0
                  }, t), void 0, !0) : t.sortable ? (S(), k("i", {
                    key: t.sortType ? t.sortType : "none",
                    class: J(["sortType-icon", { desc: t.sortType === "desc" }])
                  }, null, 2)) : te("", !0)
                ])
              ], 10, Xe))), 128))
            ])
          ], 2)) : te("", !0),
          z("tbody", null, [
            (S(!0), k(U, null, Y(e(me), (t, b) => {
              var x;
              return S(), k("tr", {
                id: `row-${b}`,
                key: b,
                class: J([
                  { [u.oddRowClass]: (b + 1) % 2 === 0 },
                  { [u.evenRowClass]: b % 2 === 0 },
                  ...((x = e(Se)) == null ? void 0 : x({ index: b, item: t })) ?? []
                ]),
                role: "button",
                tabindex: 0
              }, [
                (S(!0), k(U, null, Y(e(G), (D, X) => {
                  var be;
                  return S(), k("td", {
                    key: X,
                    role: e(G)[X].clickable || e(G)[X].hoverable ? "button" : "",
                    tabindex: "0",
                    class: J([
                      {
                        [u.oddRowCellClass]: (b + 1) % 2 === 0,
                        [u.evenRowCellClass]: b % 2 === 0,
                        shadow: X === 0,
                        [D.cssClass ?? ""]: !0,
                        [D.type ?? ""]: !0
                      },
                      ...((be = e(ke)) == null ? void 0 : be({
                        header: D,
                        item: e(y) && D.pivotValue ? t.items.find((W) => W[e(y).value] === D.pivotValue) : e(y) ? t.dimensions : t,
                        index: b
                      })) ?? []
                    ]),
                    onClick: (W) => Ve(t, e(G)[X], b, W),
                    onMouseover: (W) => ee("mouseover", t, e(G)[X], W),
                    onMouseleave: (W) => ee("mouseleave", t, W)
                  }, [
                    e(_)[`item-${D.value}`] ? $(u.$slots, `item-${D.value}`, j(
                      {
                        key: 0,
                        ref_for: !0
                      },
                      e(y) && D.pivotValue ? t.items.find((W) => W[e(y).value] === D.pivotValue) : e(y) ? t.dimensions : t
                    ), void 0, !0) : e(_).item ? $(u.$slots, "item", j({
                      key: 1,
                      ref_for: !0
                    }, { pivot: e(y), item: t }), void 0, !0) : e(y) ? (S(), k(U, { key: 2 }, [
                      K(M(e(Ce)(D, t, e(y), e(H), e(E))), 1)
                    ], 64)) : (S(), k(U, { key: 3 }, [
                      K(M(e(he)(D, t, e(H), e(E))), 1)
                    ], 64))
                  ], 42, tt);
                }), 128))
              ], 10, et);
            }), 128))
          ]),
          e(_)["customize-footers"] ? $(u.$slots, "customize-footers", ve(j({ key: 2 }, {
            headersForRender: e(G),
            updateSortField: e(se),
            generateCellContentBasedOnPivot: e(Ce),
            generateCellContent: e(he),
            locale: e(H)
          })), void 0, !0) : te("", !0)
        ], 10, Ue)
      ], 34),
      i.value.length ? $(u.$slots, "errors", { key: 0 }, () => [
        z("div", st, [
          z("ul", null, [
            (S(!0), k(U, null, Y(i.value, (t, b) => (S(), k("li", {
              key: "error" + b
            }, [
              z("span", rt, M(t.type) + ":", 1),
              K(" " + M(t.text), 1)
            ]))), 128))
          ])
        ])
      ], !0) : e(f) ? $(u.$slots, "loading", { key: 1 }, () => [
        A[3] || (A[3] = K(" Slot: loading "))
      ], !0) : !e(n).length && !e(f) && e(h) ? $(u.$slots, "no-rows-custom", { key: 2 }, () => [
        A[4] || (A[4] = K(" Slot: no-rows-custom "))
      ], !0) : !e(n).length && !e(f) ? $(u.$slots, "no-rows", { key: 3 }, () => [
        K(M(e(Q)), 1)
      ], !0) : !e(me).length && !e(f) ? $(u.$slots, "empty-message", { key: 4 }, () => [
        K(M(e(Q)), 1)
      ], !0) : te("", !0),
      e(_).footer ? $(u.$slots, "footer", ve(j({ key: 5 }, {
        currentPageFirstIndex: e(pe),
        currentPageLastIndex: e(ce),
        rowsOfPageSeparatorMessage: u.rowsOfPageSeparatorMessage,
        totalItemsLength: e(re),
        isFirstPage: e(ge),
        isLastPage: e(ye),
        currentPaginationNumber: e(ie),
        maxPaginationNumber: e(de),
        nextPage: e(ne),
        prevPage: e(ae),
        updatePage: e(le)
      })), void 0, !0) : e(B) ? te("", !0) : (S(), k("div", ot, [
        K(M(`${e(pe)}–${e(ce)}`) + " " + M(u.rowsOfPageSeparatorMessage) + " " + M(e(re)) + " ", 1),
        z("button", {
          onClick: A[1] || (A[1] = //@ts-ignore
          (...t) => e(ae) && e(ae)(...t))
        }, M("<")),
        K(" " + M(e(N)) + " of " + M(e(de)) + " ", 1),
        z("button", {
          onClick: A[2] || (A[2] = //@ts-ignore
          (...t) => e(ne) && e(ne)(...t))
        }, ">")
      ]))
    ], 64));
  }
});
const at = (s, a) => {
  const p = s.__vccOpts || s;
  for (const [i, o] of a)
    p[i] = o;
  return p;
}, it = /* @__PURE__ */ at(nt, [["__scopeId", "data-v-6c36e521"]]);
export {
  it as default
};
